from ....tl.mtproto_request import MTProtoRequest


class ConfirmPhoneRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.confirmPhone#5f2178c3 phone_code_hash:string phone_code:string = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x5f2178c3

    def __init__(self, phone_code_hash, phone_code):
        """
        :param phone_code_hash: Telegram type: «string».
        :param phone_code: Telegram type: «string».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.phone_code_hash = phone_code_hash
        self.phone_code = phone_code

    def on_send(self, writer):
        writer.write_int(ConfirmPhoneRequest.constructor_id, signed=False)
        writer.tgwrite_string(self.phone_code_hash)
        writer.tgwrite_string(self.phone_code)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ConfirmPhoneRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.confirmPhone#5f2178c3 phone_code_hash:string phone_code:string = Bool'

    def __str__(self):
        return '(account.confirmPhone (ID: 0x5f2178c3) = (phone_code_hash={}, phone_code={}))'.format(str(self.phone_code_hash), str(self.phone_code))
