from ....tl.mtproto_request import MTProtoRequest


class GetNotifySettingsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.getNotifySettings#12b3ad31 peer:InputNotifyPeer = PeerNotifySettings"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x12b3ad31

    def __init__(self, peer):
        """
        :param peer: Telegram type: «InputNotifyPeer».

        :returns PeerNotifySettings: Instance of either PeerNotifySettingsEmpty, PeerNotifySettings.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer

    def on_send(self, writer):
        writer.write_int(GetNotifySettingsRequest.constructor_id, signed=False)
        self.peer.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetNotifySettingsRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.getNotifySettings#12b3ad31 peer:InputNotifyPeer = PeerNotifySettings'

    def __str__(self):
        return '(account.getNotifySettings (ID: 0x12b3ad31) = (peer={}))'.format(str(self.peer))
