from ....tl.mtproto_request import MTProtoRequest


class UpdateNotifySettingsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.updateNotifySettings#84be5b93 peer:InputNotifyPeer settings:InputPeerNotifySettings = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x84be5b93

    def __init__(self, peer, settings):
        """
        :param peer: Telegram type: «InputNotifyPeer».
        :param settings: Telegram type: «InputPeerNotifySettings».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer
        self.settings = settings

    def on_send(self, writer):
        writer.write_int(UpdateNotifySettingsRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        self.settings.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return UpdateNotifySettingsRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.updateNotifySettings#84be5b93 peer:InputNotifyPeer settings:InputPeerNotifySettings = Bool'

    def __str__(self):
        return '(account.updateNotifySettings (ID: 0x84be5b93) = (peer={}, settings={}))'.format(str(self.peer), str(self.settings))
