from ....tl.mtproto_request import MTProtoRequest


class DeleteChannelRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.deleteChannel#c0111fe3 channel:InputChannel = Updates"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xc0111fe3

    def __init__(self, channel):
        """
        :param channel: Telegram type: «InputChannel».

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.channel = channel

    def on_send(self, writer):
        writer.write_int(DeleteChannelRequest.constructor_id, signed=False)
        self.channel.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return DeleteChannelRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.deleteChannel#c0111fe3 channel:InputChannel = Updates'

    def __str__(self):
        return '(channels.deleteChannel (ID: 0xc0111fe3) = (channel={}))'.format(str(self.channel))
