from ....tl.mtproto_request import MTProtoRequest


class EditAboutRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.editAbout#13e27f1e channel:InputChannel about:string = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x13e27f1e

    def __init__(self, channel, about):
        """
        :param channel: Telegram type: «InputChannel».
        :param about: Telegram type: «string».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.channel = channel
        self.about = about

    def on_send(self, writer):
        writer.write_int(EditAboutRequest.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.tgwrite_string(self.about)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return EditAboutRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.editAbout#13e27f1e channel:InputChannel about:string = Bool'

    def __str__(self):
        return '(channels.editAbout (ID: 0x13e27f1e) = (channel={}, about={}))'.format(str(self.channel), str(self.about))
