from ....tl.mtproto_request import MTProtoRequest


class EditTitleRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.editTitle#566decd0 channel:InputChannel title:string = Updates"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x566decd0

    def __init__(self, channel, title):
        """
        :param channel: Telegram type: «InputChannel».
        :param title: Telegram type: «string».

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.channel = channel
        self.title = title

    def on_send(self, writer):
        writer.write_int(EditTitleRequest.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.tgwrite_string(self.title)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return EditTitleRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.editTitle#566decd0 channel:InputChannel title:string = Updates'

    def __str__(self):
        return '(channels.editTitle (ID: 0x566decd0) = (channel={}, title={}))'.format(str(self.channel), str(self.title))
