from ....tl.mtproto_request import MTProtoRequest


class ToggleInvitesRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.toggleInvites#49609307 channel:InputChannel enabled:Bool = Updates"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x49609307

    def __init__(self, channel, enabled):
        """
        :param channel: Telegram type: «InputChannel».
        :param enabled: Telegram type: «Bool».

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.channel = channel
        self.enabled = enabled

    def on_send(self, writer):
        writer.write_int(ToggleInvitesRequest.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.tgwrite_bool(self.enabled)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ToggleInvitesRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.toggleInvites#49609307 channel:InputChannel enabled:Bool = Updates'

    def __str__(self):
        return '(channels.toggleInvites (ID: 0x49609307) = (channel={}, enabled={}))'.format(str(self.channel), str(self.enabled))
