from ....tl.mtproto_request import MTProtoRequest


class BlockRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    contacts.block#332b49fc id:InputUser = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x332b49fc

    def __init__(self, id):
        """
        :param id: Telegram type: «InputUser».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.id = id

    def on_send(self, writer):
        writer.write_int(BlockRequest.constructor_id, signed=False)
        self.id.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return BlockRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'contacts.block#332b49fc id:InputUser = Bool'

    def __str__(self):
        return '(contacts.block (ID: 0x332b49fc) = (id={}))'.format(str(self.id))
