from ....tl.mtproto_request import MTProtoRequest


class GetBlockedRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    contacts.getBlocked#f57c350f offset:int limit:int = contacts.Blocked"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xf57c350f

    def __init__(self, offset, limit):
        """
        :param offset: Telegram type: «int».
        :param limit: Telegram type: «int».

        :returns contacts.Blocked: Instance of either Blocked, BlockedSlice.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.offset = offset
        self.limit = limit

    def on_send(self, writer):
        writer.write_int(GetBlockedRequest.constructor_id, signed=False)
        writer.write_int(self.offset)
        writer.write_int(self.limit)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetBlockedRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'contacts.getBlocked#f57c350f offset:int limit:int = contacts.Blocked'

    def __str__(self):
        return '(contacts.getBlocked (ID: 0xf57c350f) = (offset={}, limit={}))'.format(str(self.offset), str(self.limit))
