from ....tl.mtproto_request import MTProtoRequest


class ResetTopPeerRatingRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    contacts.resetTopPeerRating#1ae373ac category:TopPeerCategory peer:InputPeer = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x1ae373ac

    def __init__(self, category, peer):
        """
        :param category: Telegram type: «TopPeerCategory».
        :param peer: Telegram type: «InputPeer».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.category = category
        self.peer = peer

    def on_send(self, writer):
        writer.write_int(ResetTopPeerRatingRequest.constructor_id, signed=False)
        self.category.on_send(writer)
        self.peer.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ResetTopPeerRatingRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'contacts.resetTopPeerRating#1ae373ac category:TopPeerCategory peer:InputPeer = Bool'

    def __str__(self):
        return '(contacts.resetTopPeerRating (ID: 0x1ae373ac) = (category={}, peer={}))'.format(str(self.category), str(self.peer))
