from ....tl.mtproto_request import MTProtoRequest


class AddChatUserRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.addChatUser#f9a0aa09 chat_id:int user_id:InputUser fwd_limit:int = Updates"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xf9a0aa09

    def __init__(self, chat_id, user_id, fwd_limit):
        """
        :param chat_id: Telegram type: «int».
        :param user_id: Telegram type: «InputUser».
        :param fwd_limit: Telegram type: «int».

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.chat_id = chat_id
        self.user_id = user_id
        self.fwd_limit = fwd_limit

    def on_send(self, writer):
        writer.write_int(AddChatUserRequest.constructor_id, signed=False)
        writer.write_int(self.chat_id)
        self.user_id.on_send(writer)
        writer.write_int(self.fwd_limit)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return AddChatUserRequest(None, None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.addChatUser#f9a0aa09 chat_id:int user_id:InputUser fwd_limit:int = Updates'

    def __str__(self):
        return '(messages.addChatUser (ID: 0xf9a0aa09) = (chat_id={}, user_id={}, fwd_limit={}))'.format(str(self.chat_id), str(self.user_id), str(self.fwd_limit))
