from ....tl.mtproto_request import MTProtoRequest


class GetChatsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.getChats#3c6aa187 id:Vector<int> = messages.Chats"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x3c6aa187

    def __init__(self, id):
        """
        :param id: Telegram type: «int». Must be a list.

        :returns messages.Chats: Instance of either Chats, ChatsSlice.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.id = id

    def on_send(self, writer):
        writer.write_int(GetChatsRequest.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.id))
        for id_item in self.id:
            writer.write_int(id_item)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetChatsRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getChats#3c6aa187 id:Vector<int> = messages.Chats'

    def __str__(self):
        return '(messages.getChats (ID: 0x3c6aa187) = (id={}))'.format(None if not self.id else [str(_) for _ in self.id])
