from ....tl.mtproto_request import MTProtoRequest


class GetFeaturedStickersRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.getFeaturedStickers#2dacca4f hash:int = messages.FeaturedStickers"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x2dacca4f

    def __init__(self, hash):
        """
        :param hash: Telegram type: «int».

        :returns messages.FeaturedStickers: Instance of either FeaturedStickersNotModified, FeaturedStickers.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.hash = hash

    def on_send(self, writer):
        writer.write_int(GetFeaturedStickersRequest.constructor_id, signed=False)
        writer.write_int(self.hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetFeaturedStickersRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getFeaturedStickers#2dacca4f hash:int = messages.FeaturedStickers'

    def __str__(self):
        return '(messages.getFeaturedStickers (ID: 0x2dacca4f) = (hash={}))'.format(str(self.hash))
