from ....tl.mtproto_request import MTProtoRequest


class GetSavedGifsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.getSavedGifs#83bf3d52 hash:int = messages.SavedGifs"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x83bf3d52

    def __init__(self, hash):
        """
        :param hash: Telegram type: «int».

        :returns messages.SavedGifs: Instance of either SavedGifsNotModified, SavedGifs.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.hash = hash

    def on_send(self, writer):
        writer.write_int(GetSavedGifsRequest.constructor_id, signed=False)
        writer.write_int(self.hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetSavedGifsRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getSavedGifs#83bf3d52 hash:int = messages.SavedGifs'

    def __str__(self):
        return '(messages.getSavedGifs (ID: 0x83bf3d52) = (hash={}))'.format(str(self.hash))
