from ....tl.mtproto_request import MTProtoRequest


class ImportChatInviteRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.importChatInvite#6c50051c hash:string = Updates"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x6c50051c

    def __init__(self, hash):
        """
        :param hash: Telegram type: «string».

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.hash = hash

    def on_send(self, writer):
        writer.write_int(ImportChatInviteRequest.constructor_id, signed=False)
        writer.tgwrite_string(self.hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ImportChatInviteRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.importChatInvite#6c50051c hash:string = Updates'

    def __str__(self):
        return '(messages.importChatInvite (ID: 0x6c50051c) = (hash={}))'.format(str(self.hash))
