from ....tl.mtproto_request import MTProtoRequest


class ReportSpamRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.reportSpam#cf1592db peer:InputPeer = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xcf1592db

    def __init__(self, peer):
        """
        :param peer: Telegram type: «InputPeer».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer

    def on_send(self, writer):
        writer.write_int(ReportSpamRequest.constructor_id, signed=False)
        self.peer.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ReportSpamRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.reportSpam#cf1592db peer:InputPeer = Bool'

    def __str__(self):
        return '(messages.reportSpam (ID: 0xcf1592db) = (peer={}))'.format(str(self.peer))
