from ....tl.mtproto_request import MTProtoRequest


class SetTypingRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.setTyping#a3825e50 peer:InputPeer action:SendMessageAction = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xa3825e50

    def __init__(self, peer, action):
        """
        :param peer: Telegram type: «InputPeer».
        :param action: Telegram type: «SendMessageAction».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer
        self.action = action

    def on_send(self, writer):
        writer.write_int(SetTypingRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        self.action.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return SetTypingRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.setTyping#a3825e50 peer:InputPeer action:SendMessageAction = Bool'

    def __str__(self):
        return '(messages.setTyping (ID: 0xa3825e50) = (peer={}, action={}))'.format(str(self.peer), str(self.action))
