from ....tl.mtproto_request import MTProtoRequest


class GetPaymentReceiptRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    payments.getPaymentReceipt#a092a980 msg_id:int = payments.PaymentReceipt"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xa092a980

    def __init__(self, msg_id):
        """
        :param msg_id: Telegram type: «int».

        :returns payments.PaymentReceipt: Instance of PaymentReceipt.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.msg_id = msg_id

    def on_send(self, writer):
        writer.write_int(GetPaymentReceiptRequest.constructor_id, signed=False)
        writer.write_int(self.msg_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetPaymentReceiptRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'payments.getPaymentReceipt#a092a980 msg_id:int = payments.PaymentReceipt'

    def __str__(self):
        return '(payments.getPaymentReceipt (ID: 0xa092a980) = (msg_id={}))'.format(str(self.msg_id))
