from ....tl.mtproto_request import MTProtoRequest


class ReceivedCallRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    phone.receivedCall#17d54f61 peer:InputPhoneCall = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x17d54f61

    def __init__(self, peer):
        """
        :param peer: Telegram type: «InputPhoneCall».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer

    def on_send(self, writer):
        writer.write_int(ReceivedCallRequest.constructor_id, signed=False)
        self.peer.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ReceivedCallRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'phone.receivedCall#17d54f61 peer:InputPhoneCall = Bool'

    def __str__(self):
        return '(phone.receivedCall (ID: 0x17d54f61) = (peer={}))'.format(str(self.peer))
