from ....tl.mtproto_request import MTProtoRequest


class SaveCallDebugRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    phone.saveCallDebug#277add7e peer:InputPhoneCall debug:DataJSON = Bool"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x277add7e

    def __init__(self, peer, debug):
        """
        :param peer: Telegram type: «InputPhoneCall».
        :param debug: Telegram type: «DataJSON».

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer
        self.debug = debug

    def on_send(self, writer):
        writer.write_int(SaveCallDebugRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        self.debug.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return SaveCallDebugRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'phone.saveCallDebug#277add7e peer:InputPhoneCall debug:DataJSON = Bool'

    def __str__(self):
        return '(phone.saveCallDebug (ID: 0x277add7e) = (peer={}, debug={}))'.format(str(self.peer), str(self.debug))
