from ....tl.mtproto_request import MTProtoRequest


class GetWebFileRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    upload.getWebFile#24e6818d location:InputWebFileLocation offset:int limit:int = upload.WebFile"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x24e6818d

    def __init__(self, location, offset, limit):
        """
        :param location: Telegram type: «InputWebFileLocation».
        :param offset: Telegram type: «int».
        :param limit: Telegram type: «int».

        :returns upload.WebFile: Instance of WebFile.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.location = location
        self.offset = offset
        self.limit = limit

    def on_send(self, writer):
        writer.write_int(GetWebFileRequest.constructor_id, signed=False)
        self.location.on_send(writer)
        writer.write_int(self.offset)
        writer.write_int(self.limit)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return GetWebFileRequest(None, None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'upload.getWebFile#24e6818d location:InputWebFileLocation offset:int limit:int = upload.WebFile'

    def __str__(self):
        return '(upload.getWebFile (ID: 0x24e6818d) = (location={}, offset={}, limit={}))'.format(str(self.location), str(self.offset), str(self.limit))
