from ...tl.mtproto_request import MTProtoRequest


class ChannelParticipant(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channelParticipant#15ebac1d user_id:int date:date = ChannelParticipant"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x15ebac1d

    def __init__(self, user_id, date):
        """
        :param user_id: Telegram type: «int».
        :param date: Telegram type: «date».

        Constructor for ChannelParticipant: Instance of either ChannelParticipant, ChannelParticipantSelf, ChannelParticipantModerator, ChannelParticipantEditor, ChannelParticipantKicked, ChannelParticipantCreator.
        """
        super().__init__()

        self.user_id = user_id
        self.date = date

    def on_send(self, writer):
        writer.write_int(ChannelParticipant.constructor_id, signed=False)
        writer.write_int(self.user_id)
        writer.tgwrite_date(self.date)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ChannelParticipant(None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.date = reader.tgread_date()

    def __repr__(self):
        return 'channelParticipant#15ebac1d user_id:int date:date = ChannelParticipant'

    def __str__(self):
        return '(channelParticipant (ID: 0x15ebac1d) = (user_id={}, date={}))'.format(str(self.user_id), str(self.date))
