from ...tl.mtproto_request import MTProtoRequest


class ChatForbidden(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    chatForbidden#07328bdb id:int title:string = Chat"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x7328bdb

    def __init__(self, id, title):
        """
        :param id: Telegram type: «int».
        :param title: Telegram type: «string».

        Constructor for Chat: Instance of either ChatEmpty, Chat, ChatForbidden, Channel, ChannelForbidden.
        """
        super().__init__()

        self.id = id
        self.title = title

    def on_send(self, writer):
        writer.write_int(ChatForbidden.constructor_id, signed=False)
        writer.write_int(self.id)
        writer.tgwrite_string(self.title)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ChatForbidden(None, None)

    def on_response(self, reader):
        self.id = reader.read_int()
        self.title = reader.tgread_string()

    def __repr__(self):
        return 'chatForbidden#07328bdb id:int title:string = Chat'

    def __str__(self):
        return '(chatForbidden (ID: 0x7328bdb) = (id={}, title={}))'.format(str(self.id), str(self.title))
