from ...tl.mtproto_request import MTProtoRequest


class ChatParticipantAdmin(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    chatParticipantAdmin#e2d6e436 user_id:int inviter_id:int date:date = ChatParticipant"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xe2d6e436

    def __init__(self, user_id, inviter_id, date):
        """
        :param user_id: Telegram type: «int».
        :param inviter_id: Telegram type: «int».
        :param date: Telegram type: «date».

        Constructor for ChatParticipant: Instance of either ChatParticipant, ChatParticipantCreator, ChatParticipantAdmin.
        """
        super().__init__()

        self.user_id = user_id
        self.inviter_id = inviter_id
        self.date = date

    def on_send(self, writer):
        writer.write_int(ChatParticipantAdmin.constructor_id, signed=False)
        writer.write_int(self.user_id)
        writer.write_int(self.inviter_id)
        writer.tgwrite_date(self.date)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ChatParticipantAdmin(None, None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.inviter_id = reader.read_int()
        self.date = reader.tgread_date()

    def __repr__(self):
        return 'chatParticipantAdmin#e2d6e436 user_id:int inviter_id:int date:date = ChatParticipant'

    def __str__(self):
        return '(chatParticipantAdmin (ID: 0xe2d6e436) = (user_id={}, inviter_id={}, date={}))'.format(str(self.user_id), str(self.inviter_id), str(self.date))
