from ...tl.mtproto_request import MTProtoRequest


class ContactStatus(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    contactStatus#d3680c61 user_id:int status:UserStatus = ContactStatus"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xd3680c61

    def __init__(self, user_id, status):
        """
        :param user_id: Telegram type: «int».
        :param status: Telegram type: «UserStatus».

        Constructor for ContactStatus: Instance of ContactStatus.
        """
        super().__init__()

        self.user_id = user_id
        self.status = status

    def on_send(self, writer):
        writer.write_int(ContactStatus.constructor_id, signed=False)
        writer.write_int(self.user_id)
        self.status.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ContactStatus(None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.status = reader.tgread_object()

    def __repr__(self):
        return 'contactStatus#d3680c61 user_id:int status:UserStatus = ContactStatus'

    def __str__(self):
        return '(contactStatus (ID: 0xd3680c61) = (user_id={}, status={}))'.format(str(self.user_id), str(self.status))
