from ...tl.mtproto_request import MTProtoRequest


class DraftMessageEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    draftMessageEmpty#ba4baec5  = DraftMessage"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xba4baec5

    def __init__(self):
        super().__init__()

    def on_send(self, writer):
        writer.write_int(DraftMessageEmpty.constructor_id, signed=False)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return DraftMessageEmpty()

    def on_response(self, reader):
        pass

    def __repr__(self):
        return 'draftMessageEmpty#ba4baec5  = DraftMessage'

    def __str__(self):
        return '(draftMessageEmpty (ID: 0xba4baec5) = ())'.format()
