from ...tl.mtproto_request import MTProtoRequest


class EncryptedChatEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    encryptedChatEmpty#ab7ec0a0 id:int = EncryptedChat"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xab7ec0a0

    def __init__(self, id):
        """
        :param id: Telegram type: «int».

        Constructor for EncryptedChat: Instance of either EncryptedChatEmpty, EncryptedChatWaiting, EncryptedChatRequested, EncryptedChat, EncryptedChatDiscarded.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(EncryptedChatEmpty.constructor_id, signed=False)
        writer.write_int(self.id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return EncryptedChatEmpty(None)

    def on_response(self, reader):
        self.id = reader.read_int()

    def __repr__(self):
        return 'encryptedChatEmpty#ab7ec0a0 id:int = EncryptedChat'

    def __str__(self):
        return '(encryptedChatEmpty (ID: 0xab7ec0a0) = (id={}))'.format(str(self.id))
