from ...tl.mtproto_request import MTProtoRequest


class EncryptedFileEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    encryptedFileEmpty#c21f497e  = EncryptedFile"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xc21f497e

    def __init__(self):
        super().__init__()

    def on_send(self, writer):
        writer.write_int(EncryptedFileEmpty.constructor_id, signed=False)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return EncryptedFileEmpty()

    def on_response(self, reader):
        pass

    def __repr__(self):
        return 'encryptedFileEmpty#c21f497e  = EncryptedFile'

    def __str__(self):
        return '(encryptedFileEmpty (ID: 0xc21f497e) = ())'.format()
