from ...tl.mtproto_request import MTProtoRequest


class InputChatPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputChatPhoto#8953ad37 id:InputPhoto = InputChatPhoto"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x8953ad37

    def __init__(self, id):
        """
        :param id: Telegram type: «InputPhoto».

        Constructor for InputChatPhoto: Instance of either InputChatPhotoEmpty, InputChatUploadedPhoto, InputChatPhoto.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(InputChatPhoto.constructor_id, signed=False)
        self.id.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputChatPhoto(None)

    def on_response(self, reader):
        self.id = reader.tgread_object()

    def __repr__(self):
        return 'inputChatPhoto#8953ad37 id:InputPhoto = InputChatPhoto'

    def __str__(self):
        return '(inputChatPhoto (ID: 0x8953ad37) = (id={}))'.format(str(self.id))
