from ...tl.mtproto_request import MTProtoRequest


class InputChatUploadedPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputChatUploadedPhoto#927c55b4 file:InputFile = InputChatPhoto"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x927c55b4

    def __init__(self, file):
        """
        :param file: Telegram type: «InputFile».

        Constructor for InputChatPhoto: Instance of either InputChatPhotoEmpty, InputChatUploadedPhoto, InputChatPhoto.
        """
        super().__init__()

        self.file = file

    def on_send(self, writer):
        writer.write_int(InputChatUploadedPhoto.constructor_id, signed=False)
        self.file.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputChatUploadedPhoto(None)

    def on_response(self, reader):
        self.file = reader.tgread_object()

    def __repr__(self):
        return 'inputChatUploadedPhoto#927c55b4 file:InputFile = InputChatPhoto'

    def __str__(self):
        return '(inputChatUploadedPhoto (ID: 0x927c55b4) = (file={}))'.format(str(self.file))
