from ...tl.mtproto_request import MTProtoRequest


class InputDocument(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputDocument#18798952 id:long access_hash:long = InputDocument"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x18798952

    def __init__(self, id, access_hash):
        """
        :param id: Telegram type: «long».
        :param access_hash: Telegram type: «long».

        Constructor for InputDocument: Instance of either InputDocumentEmpty, InputDocument.
        """
        super().__init__()

        self.id = id
        self.access_hash = access_hash

    def on_send(self, writer):
        writer.write_int(InputDocument.constructor_id, signed=False)
        writer.write_long(self.id)
        writer.write_long(self.access_hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputDocument(None, None)

    def on_response(self, reader):
        self.id = reader.read_long()
        self.access_hash = reader.read_long()

    def __repr__(self):
        return 'inputDocument#18798952 id:long access_hash:long = InputDocument'

    def __str__(self):
        return '(inputDocument (ID: 0x18798952) = (id={}, access_hash={}))'.format(str(self.id), str(self.access_hash))
