from ...tl.mtproto_request import MTProtoRequest


class InputMediaDocument(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputMediaDocument#1a77f29c id:InputDocument caption:string = InputMedia"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x1a77f29c

    def __init__(self, id, caption):
        """
        :param id: Telegram type: «InputDocument».
        :param caption: Telegram type: «string».

        Constructor for InputMedia: Instance of either InputMediaEmpty, InputMediaUploadedPhoto, InputMediaPhoto, InputMediaGeoPoint, InputMediaContact, InputMediaUploadedDocument, InputMediaUploadedThumbDocument, InputMediaDocument, InputMediaVenue, InputMediaGifExternal, InputMediaPhotoExternal, InputMediaDocumentExternal, InputMediaGame, InputMediaInvoice.
        """
        super().__init__()

        self.id = id
        self.caption = caption

    def on_send(self, writer):
        writer.write_int(InputMediaDocument.constructor_id, signed=False)
        self.id.on_send(writer)
        writer.tgwrite_string(self.caption)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputMediaDocument(None, None)

    def on_response(self, reader):
        self.id = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaDocument#1a77f29c id:InputDocument caption:string = InputMedia'

    def __str__(self):
        return '(inputMediaDocument (ID: 0x1a77f29c) = (id={}, caption={}))'.format(str(self.id), str(self.caption))
