from ...tl.mtproto_request import MTProtoRequest


class InputMediaPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputMediaPhoto#e9bfb4f3 id:InputPhoto caption:string = InputMedia"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xe9bfb4f3

    def __init__(self, id, caption):
        """
        :param id: Telegram type: «InputPhoto».
        :param caption: Telegram type: «string».

        Constructor for InputMedia: Instance of either InputMediaEmpty, InputMediaUploadedPhoto, InputMediaPhoto, InputMediaGeoPoint, InputMediaContact, InputMediaUploadedDocument, InputMediaUploadedThumbDocument, InputMediaDocument, InputMediaVenue, InputMediaGifExternal, InputMediaPhotoExternal, InputMediaDocumentExternal, InputMediaGame, InputMediaInvoice.
        """
        super().__init__()

        self.id = id
        self.caption = caption

    def on_send(self, writer):
        writer.write_int(InputMediaPhoto.constructor_id, signed=False)
        self.id.on_send(writer)
        writer.tgwrite_string(self.caption)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputMediaPhoto(None, None)

    def on_response(self, reader):
        self.id = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaPhoto#e9bfb4f3 id:InputPhoto caption:string = InputMedia'

    def __str__(self):
        return '(inputMediaPhoto (ID: 0xe9bfb4f3) = (id={}, caption={}))'.format(str(self.id), str(self.caption))
