from ...tl.mtproto_request import MTProtoRequest


class InputPhoneCall(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputPhoneCall#1e36fded id:long access_hash:long = InputPhoneCall"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x1e36fded

    def __init__(self, id, access_hash):
        """
        :param id: Telegram type: «long».
        :param access_hash: Telegram type: «long».

        Constructor for InputPhoneCall: Instance of InputPhoneCall.
        """
        super().__init__()

        self.id = id
        self.access_hash = access_hash

    def on_send(self, writer):
        writer.write_int(InputPhoneCall.constructor_id, signed=False)
        writer.write_long(self.id)
        writer.write_long(self.access_hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputPhoneCall(None, None)

    def on_response(self, reader):
        self.id = reader.read_long()
        self.access_hash = reader.read_long()

    def __repr__(self):
        return 'inputPhoneCall#1e36fded id:long access_hash:long = InputPhoneCall'

    def __str__(self):
        return '(inputPhoneCall (ID: 0x1e36fded) = (id={}, access_hash={}))'.format(str(self.id), str(self.access_hash))
