from ...tl.mtproto_request import MTProtoRequest


class InputReportReasonOther(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputReportReasonOther#e1746d0a text:string = ReportReason"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xe1746d0a

    def __init__(self, text):
        """
        :param text: Telegram type: «string».

        Constructor for ReportReason: Instance of either InputReportReasonSpam, InputReportReasonViolence, InputReportReasonPornography, InputReportReasonOther.
        """
        super().__init__()

        self.text = text

    def on_send(self, writer):
        writer.write_int(InputReportReasonOther.constructor_id, signed=False)
        writer.tgwrite_string(self.text)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputReportReasonOther(None)

    def on_response(self, reader):
        self.text = reader.tgread_string()

    def __repr__(self):
        return 'inputReportReasonOther#e1746d0a text:string = ReportReason'

    def __str__(self):
        return '(inputReportReasonOther (ID: 0xe1746d0a) = (text={}))'.format(str(self.text))
