from ...tl.mtproto_request import MTProtoRequest


class InputStickeredMediaPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputStickeredMediaPhoto#4a992157 id:InputPhoto = InputStickeredMedia"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x4a992157

    def __init__(self, id):
        """
        :param id: Telegram type: «InputPhoto».

        Constructor for InputStickeredMedia: Instance of either InputStickeredMediaPhoto, InputStickeredMediaDocument.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(InputStickeredMediaPhoto.constructor_id, signed=False)
        self.id.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return InputStickeredMediaPhoto(None)

    def on_response(self, reader):
        self.id = reader.tgread_object()

    def __repr__(self):
        return 'inputStickeredMediaPhoto#4a992157 id:InputPhoto = InputStickeredMedia'

    def __str__(self):
        return '(inputStickeredMediaPhoto (ID: 0x4a992157) = (id={}))'.format(str(self.id))
