from ...tl.mtproto_request import MTProtoRequest


class MessageActionChatDeleteUser(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messageActionChatDeleteUser#b2ae9b0c user_id:int = MessageAction"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xb2ae9b0c

    def __init__(self, user_id):
        """
        :param user_id: Telegram type: «int».

        Constructor for MessageAction: Instance of either MessageActionEmpty, MessageActionChatCreate, MessageActionChatEditTitle, MessageActionChatEditPhoto, MessageActionChatDeletePhoto, MessageActionChatAddUser, MessageActionChatDeleteUser, MessageActionChatJoinedByLink, MessageActionChannelCreate, MessageActionChatMigrateTo, MessageActionChannelMigrateFrom, MessageActionPinMessage, MessageActionHistoryClear, MessageActionGameScore, MessageActionPaymentSentMe, MessageActionPaymentSent, MessageActionPhoneCall.
        """
        super().__init__()

        self.user_id = user_id

    def on_send(self, writer):
        writer.write_int(MessageActionChatDeleteUser.constructor_id, signed=False)
        writer.write_int(self.user_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return MessageActionChatDeleteUser(None)

    def on_response(self, reader):
        self.user_id = reader.read_int()

    def __repr__(self):
        return 'messageActionChatDeleteUser#b2ae9b0c user_id:int = MessageAction'

    def __str__(self):
        return '(messageActionChatDeleteUser (ID: 0xb2ae9b0c) = (user_id={}))'.format(str(self.user_id))
