from ...tl.mtproto_request import MTProtoRequest


class MessageActionChatMigrateTo(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messageActionChatMigrateTo#51bdb021 channel_id:int = MessageAction"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x51bdb021

    def __init__(self, channel_id):
        """
        :param channel_id: Telegram type: «int».

        Constructor for MessageAction: Instance of either MessageActionEmpty, MessageActionChatCreate, MessageActionChatEditTitle, MessageActionChatEditPhoto, MessageActionChatDeletePhoto, MessageActionChatAddUser, MessageActionChatDeleteUser, MessageActionChatJoinedByLink, MessageActionChannelCreate, MessageActionChatMigrateTo, MessageActionChannelMigrateFrom, MessageActionPinMessage, MessageActionHistoryClear, MessageActionGameScore, MessageActionPaymentSentMe, MessageActionPaymentSent, MessageActionPhoneCall.
        """
        super().__init__()

        self.channel_id = channel_id

    def on_send(self, writer):
        writer.write_int(MessageActionChatMigrateTo.constructor_id, signed=False)
        writer.write_int(self.channel_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return MessageActionChatMigrateTo(None)

    def on_response(self, reader):
        self.channel_id = reader.read_int()

    def __repr__(self):
        return 'messageActionChatMigrateTo#51bdb021 channel_id:int = MessageAction'

    def __str__(self):
        return '(messageActionChatMigrateTo (ID: 0x51bdb021) = (channel_id={}))'.format(str(self.channel_id))
