from ...tl.mtproto_request import MTProtoRequest


class MessageEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messageEmpty#83e5de54 id:int = Message"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x83e5de54

    def __init__(self, id):
        """
        :param id: Telegram type: «int».

        Constructor for Message: Instance of either MessageEmpty, Message, MessageService.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(MessageEmpty.constructor_id, signed=False)
        writer.write_int(self.id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return MessageEmpty(None)

    def on_response(self, reader):
        self.id = reader.read_int()

    def __repr__(self):
        return 'messageEmpty#83e5de54 id:int = Message'

    def __str__(self):
        return '(messageEmpty (ID: 0x83e5de54) = (id={}))'.format(str(self.id))
