from ...tl.mtproto_request import MTProtoRequest


class MessageEntityPre(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messageEntityPre#73924be0 offset:int length:int language:string = MessageEntity"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x73924be0

    def __init__(self, offset, length, language):
        """
        :param offset: Telegram type: «int».
        :param length: Telegram type: «int».
        :param language: Telegram type: «string».

        Constructor for MessageEntity: Instance of either MessageEntityUnknown, MessageEntityMention, MessageEntityHashtag, MessageEntityBotCommand, MessageEntityUrl, MessageEntityEmail, MessageEntityBold, MessageEntityItalic, MessageEntityCode, MessageEntityPre, MessageEntityTextUrl, MessageEntityMentionName, InputMessageEntityMentionName.
        """
        super().__init__()

        self.offset = offset
        self.length = length
        self.language = language

    def on_send(self, writer):
        writer.write_int(MessageEntityPre.constructor_id, signed=False)
        writer.write_int(self.offset)
        writer.write_int(self.length)
        writer.tgwrite_string(self.language)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return MessageEntityPre(None, None, None)

    def on_response(self, reader):
        self.offset = reader.read_int()
        self.length = reader.read_int()
        self.language = reader.tgread_string()

    def __repr__(self):
        return 'messageEntityPre#73924be0 offset:int length:int language:string = MessageEntity'

    def __str__(self):
        return '(messageEntityPre (ID: 0x73924be0) = (offset={}, length={}, language={}))'.format(str(self.offset), str(self.length), str(self.language))
