from ...tl.mtproto_request import MTProtoRequest


class Null(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    null#56730bcc  = Null"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x56730bcc

    def __init__(self):
        super().__init__()

    def on_send(self, writer):
        writer.write_int(Null.constructor_id, signed=False)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return Null()

    def on_response(self, reader):
        pass

    def __repr__(self):
        return 'null#56730bcc  = Null'

    def __str__(self):
        return '(null (ID: 0x56730bcc) = ())'.format()
