from ...tl.mtproto_request import MTProtoRequest


class PeerChat(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    peerChat#bad0e5bb chat_id:int = Peer"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xbad0e5bb

    def __init__(self, chat_id):
        """
        :param chat_id: Telegram type: «int».

        Constructor for Peer: Instance of either PeerUser, PeerChat, PeerChannel.
        """
        super().__init__()

        self.chat_id = chat_id

    def on_send(self, writer):
        writer.write_int(PeerChat.constructor_id, signed=False)
        writer.write_int(self.chat_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return PeerChat(None)

    def on_response(self, reader):
        self.chat_id = reader.read_int()

    def __repr__(self):
        return 'peerChat#bad0e5bb chat_id:int = Peer'

    def __str__(self):
        return '(peerChat (ID: 0xbad0e5bb) = (chat_id={}))'.format(str(self.chat_id))
