from ...tl.mtproto_request import MTProtoRequest


class PeerUser(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    peerUser#9db1bc6d user_id:int = Peer"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x9db1bc6d

    def __init__(self, user_id):
        """
        :param user_id: Telegram type: «int».

        Constructor for Peer: Instance of either PeerUser, PeerChat, PeerChannel.
        """
        super().__init__()

        self.user_id = user_id

    def on_send(self, writer):
        writer.write_int(PeerUser.constructor_id, signed=False)
        writer.write_int(self.user_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return PeerUser(None)

    def on_response(self, reader):
        self.user_id = reader.read_int()

    def __repr__(self):
        return 'peerUser#9db1bc6d user_id:int = Peer'

    def __str__(self):
        return '(peerUser (ID: 0x9db1bc6d) = (user_id={}))'.format(str(self.user_id))
