from ...tl.mtproto_request import MTProtoRequest


class PhoneCallEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    phoneCallEmpty#5366c915 id:long = PhoneCall"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x5366c915

    def __init__(self, id):
        """
        :param id: Telegram type: «long».

        Constructor for PhoneCall: Instance of either PhoneCallEmpty, PhoneCallWaiting, PhoneCallRequested, PhoneCallAccepted, PhoneCall, PhoneCallDiscarded.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(PhoneCallEmpty.constructor_id, signed=False)
        writer.write_long(self.id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return PhoneCallEmpty(None)

    def on_response(self, reader):
        self.id = reader.read_long()

    def __repr__(self):
        return 'phoneCallEmpty#5366c915 id:long = PhoneCall'

    def __str__(self):
        return '(phoneCallEmpty (ID: 0x5366c915) = (id={}))'.format(str(self.id))
