from ...tl.mtproto_request import MTProtoRequest


class SendMessageUploadDocumentAction(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    sendMessageUploadDocumentAction#aa0cd9e4 progress:int = SendMessageAction"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xaa0cd9e4

    def __init__(self, progress):
        """
        :param progress: Telegram type: «int».

        Constructor for SendMessageAction: Instance of either SendMessageTypingAction, SendMessageCancelAction, SendMessageRecordVideoAction, SendMessageUploadVideoAction, SendMessageRecordAudioAction, SendMessageUploadAudioAction, SendMessageUploadPhotoAction, SendMessageUploadDocumentAction, SendMessageGeoLocationAction, SendMessageChooseContactAction, SendMessageGamePlayAction, SendMessageRecordRoundAction, SendMessageUploadRoundAction.
        """
        super().__init__()

        self.progress = progress

    def on_send(self, writer):
        writer.write_int(SendMessageUploadDocumentAction.constructor_id, signed=False)
        writer.write_int(self.progress)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return SendMessageUploadDocumentAction(None)

    def on_response(self, reader):
        self.progress = reader.read_int()

    def __repr__(self):
        return 'sendMessageUploadDocumentAction#aa0cd9e4 progress:int = SendMessageAction'

    def __str__(self):
        return '(sendMessageUploadDocumentAction (ID: 0xaa0cd9e4) = (progress={}))'.format(str(self.progress))
