from ...tl.mtproto_request import MTProtoRequest


class ServerDHParamsFail(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    server_DH_params_fail#79cb045d nonce:int128 server_nonce:int128 new_nonce_hash:int128 = Server_DH_Params"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0x79cb045d

    def __init__(self, nonce, server_nonce, new_nonce_hash):
        """
        :param nonce: Telegram type: «int128».
        :param server_nonce: Telegram type: «int128».
        :param new_nonce_hash: Telegram type: «int128».

        Constructor for Server_DH_Params: Instance of either ServerDHParamsFail, ServerDHParamsOk.
        """
        super().__init__()

        self.nonce = nonce
        self.server_nonce = server_nonce
        self.new_nonce_hash = new_nonce_hash

    def on_send(self, writer):
        writer.write_int(ServerDHParamsFail.constructor_id, signed=False)
        writer.write_large_int(self.nonce, bits=128)
        writer.write_large_int(self.server_nonce, bits=128)
        writer.write_large_int(self.new_nonce_hash, bits=128)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return ServerDHParamsFail(None, None, None)

    def on_response(self, reader):
        self.nonce = reader.read_large_int(bits=128)
        self.server_nonce = reader.read_large_int(bits=128)
        self.new_nonce_hash = reader.read_large_int(bits=128)

    def __repr__(self):
        return 'server_DH_params_fail#79cb045d nonce:int128 server_nonce:int128 new_nonce_hash:int128 = Server_DH_Params'

    def __str__(self):
        return '(server_DH_params_fail (ID: 0x79cb045d) = (nonce={}, server_nonce={}, new_nonce_hash={}))'.format(str(self.nonce), str(self.server_nonce), str(self.new_nonce_hash))
