from ...tl.mtproto_request import MTProtoRequest


class WebPageEmpty(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    webPageEmpty#eb1477e8 id:long = WebPage"""

    # Telegram's constructor ID (and unique identifier) for this class
    constructor_id = 0xeb1477e8

    def __init__(self, id):
        """
        :param id: Telegram type: «long».

        Constructor for WebPage: Instance of either WebPageEmpty, WebPagePending, WebPage, WebPageNotModified.
        """
        super().__init__()

        self.id = id

    def on_send(self, writer):
        writer.write_int(WebPageEmpty.constructor_id, signed=False)
        writer.write_long(self.id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (all attributes are None)"""
        return WebPageEmpty(None)

    def on_response(self, reader):
        self.id = reader.read_long()

    def __repr__(self):
        return 'webPageEmpty#eb1477e8 id:long = WebPage'

    def __str__(self):
        return '(webPageEmpty (ID: 0xeb1477e8) = (id={}))'.format(str(self.id))
